// BasicDataType.cpp : Ce fichier contient la fonction 'main'. L'exécution du programme commence et se termine à cet endroit.
//

#include <iostream>        // pour utiliser std::cout
#include <iomanip>         // pour utiliser std::setprecision
#define _USE_MATH_DEFINES  // pour utiliser les définitions dans math.h
#include <math.h>          // la bibliothèque de fonctions mathématiques
#include <stdio.h>          // pour utiliser printf/fprintf ... les puristes C++ n'apprécieront pas

int main(void) {
    char c = 'A';
    short int s = 1024;
    int i = 100000;
    long int l = 0x7FFFFFFF;
    long long int ll = 0x7FFFFFFFFFFFFFFF;
    float f = (float)M_PI;
    double d = M_PI;
    long double ld = M_PI;
    std::cout << "Hello Data Type avec std::cout !\n";
    std::cout << "c contient " << c << " (" << (int)c << "), sa taille est " << sizeof c << " octet(s) et son adresse est " << (void*)&c << "\n";
    std::cout << "s contient " << s << ", sa taille est " << sizeof s << " octet(s) et son adresse est " << (void*)&s << "\n";
    std::cout << "i contient " << i << ", sa taille est " << sizeof i << " octet(s) et son adresse est " << (void*)&i << "\n";
    std::cout << "l contient " << l << ", sa taille est " << sizeof l << " octet(s) et son adresse est " << (void*)&l << "\n";
    std::cout << "ll contient " << ll << ", sa taille est " << sizeof ll << " octet(s) et son adresse est " << (void*)&ll << "\n";
    std::cout << std::setprecision(20);
    std::cout << "f contient " << f << ", sa taille est " << sizeof f << " octet(s) et son adresse est " << (void*)&f << "\n";
    std::cout << "d contient " << d << ", sa taille est " << sizeof d << " octet(s) et son adresse est " << (void*)&d << "\n";
    std::cout << "ld contient " << ld << ", sa taille est " << sizeof ld << " octet(s) et son adresse est " << (void*)&ld << "\n";
    fprintf(stdout, "Hello Data Type avec fprintf !\n");
    fprintf(stdout, "c contient %c (%d), sa taille est %zu octet(s) et son adresse est %p\n", c, c, sizeof c, &c);
    fprintf(stdout, "s contient %hd, sa taille est %zu octet(s) et son adresse est %p\n", s, sizeof s, &s);
    fprintf(stdout, "i contient %d, sa taille est %zu octet(s) et son adresse est %p\n", i, sizeof l, &l);
    fprintf(stdout, "l contient %ld, sa taille est %zu octet(s) et son adresse est %p\n", l, sizeof l, &l);
    fprintf(stdout, "ll contient %lld, sa taille est %zu octet(s) et son adresse est %p\n", ll, sizeof ll, &ll);
    fprintf(stdout, "f contient %1.20f, sa taille est %zu octet(s) et son adresse est %p\n", f, sizeof f, &f);
    fprintf(stdout, "d contient %1.20f, sa taille est %zu octet(s) et son adresse est %p\n", d, sizeof d, &d);
    fprintf(stdout, "ld contient %1.20Lf, sa taille est %zu octet(s) et son adresse est %p\n", ld, sizeof ld, &ld);
    return EXIT_SUCCESS;
}
